#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityChipBoxCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityChipBoxCFG> M_ActivityChipBoxCFG::msSingleton(nullptr);

int M_ActivityChipBoxCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityChipBoxCFGData* M_ActivityChipBoxCFG::GetData(std::string Key)
{
	auto it = mMapData.find(Key);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<std::string, M_ActivityChipBoxCFGData>& M_ActivityChipBoxCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityChipBoxCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityChipBoxCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityChipBoxCFGData data;
		data.mKey = element->Attribute("Key");
		data.mValue = element->IntAttribute("Value");
		data.mStringValue = element->Attribute("StringValue");
		if (mMapData.find(data.mKey) != mMapData.end())std::cout <<"data refind:" << data.mKey << std::endl;
		assert(mMapData.find(data.mKey) == mMapData.end());
		mMapData.insert(std::make_pair(data.mKey, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityChipBoxCFG::Load()
{
	Load("../Config/M_ActivityChipBoxCFG.xml");
}

M_ActivityChipBoxCFG* M_ActivityChipBoxCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityChipBoxCFG());
	}
	return msSingleton.get();
}
